/**
 * 
 */
var mX=0,mY=0;

var outputMsgs=[];
var canvas;
var cntx;

var tapping=false;

function initialise(){
	simulating=false;
	
	showAppTitle();
	showButtonCaptions();
	showProblem();
	adjustCode();
	placeContents();
	$("#drawArea").hide();
	showSimulationValues(); //καλείται για να αποκρύψει όλα τα span elements
	initialiseGraphics();
	initialiseEvents();
	showPrompt();
	setParameterValue(0,1);
}

function initialiseEvents(){
    
    $(".toChange").focus(function(){
        if(simulating){
            $("#"+this.id).blur();
        }
    });

    document.addEventListener("touchend",function(evt){
        if(tapping){
            tapping=false;
            $(".matched").removeClass("matched");
            evt.preventDefault();
            return;
        }
    });
    
	$("#clearBreakPoints").on("click touchend",function(){
	    $(".breakPointCmd").removeClass("breakPointCmd");
	});
	
	$("#visualisation").on("mousemove touchend",function(evt){
		var rect = canvas.getBoundingClientRect();
		mX=evt.clientX-rect.left;
	    mY=evt.clientY-rect.top;
		handleMouseMove();
	});
	
	$(".algoCmd").on("click touchend",function(evt){
	    if(evt.target.id.substr(0,7)=="usrEntr") return;
		if($("#"+this.id).hasClass("breakPointCmd")){
			$("#"+this.id).removeClass("breakPointCmd");
		}
		else{
			$("#"+this.id).addClass("breakPointCmd");
		}
	});

	//touch events
	$("#showInfo").on("touchend",function(evt){
	    $("#showInfo").trigger("click");
	});
	
	//Κουμπιά διαχείρισης καταχωρήσεων εξόδου
	$("#btnFirst").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(-firstVisibleCell);
	});

	$("#btnPrevious").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(-1);
	});

	$("#btnNext").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(1);
	});

	$("#btnLast").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(outputMsgs.length-1-firstVisibleCell);
	});

	//Κουμπιά διαχείρισης εφαρμογής
    $("#slideSpeed").bind("change keyup touchend",function(event,ui) {
        var maxSimSpeed=Number($(this).attr("max"))+1;
        simSpeed=maxSimSpeed-$(this).val();
    });
	
    $("#showCaptions").bind("change keyup touchend",function(event,ui) {
    	if($("#showCaptions:checked").val()=="show"){
    		buttonCaptionsVisible=true;
    	}
    	else{
    		buttonCaptionsVisible=false;
    	}
    	showButtonCaptions();
    });
    
    
    $("#showVarValues").bind("change keyup touchend",function(event,ui) {
    	if($("#showVarValues:checked").val()=="show"){
    		showVarValues=true;
    	}
    	else{
    		showVarValues=false;
    	}
    });
    
    $("#showComments").bind("change keyup touchend",function(event,ui) {
    	if($("#showComments:checked").val()=="show"){
    		$("#commentArea").slideDown("slow");
    		showComments=true;
    	}
    	else{
    		$("#commentArea").slideUp("slow");
    		showComments=false;
    	}
    });
	
    $("#requestConfirmations").bind("change keyup touchend",function(event,ui) {
    	if($("#requestConfirmations:checked").val()=="reqConfirm"){
    		requestConfirmationState=requestConfirmation;
    	}
    	else{
    		requestConfirmationState=dontRequestConfirmation;
    	}
    });
    
    $("#showFullSimulationPath").bind("change keyup touchend",function(event,ui) {
    	if($("#showFullSimulationPath:checked").val()=="showFullSimPath"){
    		hideSimulationPath=false;
    	}
    	else{
    		hideSimulationPath=true;
    	}
    });

    $("#btnPlay").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnPlay").hide();
    	$("#btnStop").show();
    	$("#btnPause").prop("disabled",false);
    	$("#btnForward").prop("disabled",true);
		//resetSimulation(); //Η εντολή απενεργοποιείται για να είναι δυνατή η αυτόματη εκτέλεση από εκεί που σταμάτησε η βηματική
    	promptID=promptDuringRunning;
    	simulationAborted=false;
    	simulateCode(true);
    });
    
    $("#btnStop").on("click touchstart",function(){
        $("#drawArea").hide(animationRate);
    	simulating=false;
    	simulateCode(false);
    	resetSimulation();
    	$("#btnPlay").show();
    	$("#btnStop").hide();
    	$("#btnPause").show();
    	$("#btnContinue").hide();
    	$("#btnForward").show();
    	if(simulationAborted){
    	    promptID=promptToFillInBlanks;
    	}
    	else{
    	    promptID=promptToRunCode;
    	}
    	showPrompt();
    });
    
    $("#btnPause").on("click touchstart",function(){
    	$("#showOptions").show();
    	simulating=false;
    	$("#btnPause").hide();
    	$("#btnContinue").show();
    	clearInterval(timerLoop);
    	handleContinuationButtons();
    	showPrompt();
    });
    
    $("#btnContinue").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnContinue").hide();
    	$("#btnForward").prop("disabled",true);
    	$("#btnPause").show();
    	simulateCode(true);
    });
                
    $("#btnForward").on("click touchstart",function(){
        $("#drawArea").show(animationRate);
        simulationAborted=false;
    	if(simulationIndex==-1){
    		resetSimulation();
    	}
    	if(simulationIndex<=parseInt(endIf1.substr(3,2))){
    		simulateRun();
    	}
    });
    
    $("#btnCheckCode").on("click touchstart",function(){
    	checkCode();
    	handleContinuationButtons();
    });

    $("#btnShowSolution").on("click touchstart",function(){
    	showSolution();
    });
    
    $("#btnShowAnalysis").on("click touchstart",function(){
    	showAnalysis();
    });

    $("#btnInitialiseCode").on("click touchstart",function(){
    	if(requestConfirmationState || confirm("ΠΡΟΣΟΧΗ! Η εντολή αυτή θα επαναφέρει τις αρχικές καταχωρήσεις και θα διαγράψει όλα τα Σημεία Διακοπής. Είσαι σίγουρος;")){
        	$(".breakPointCmd").removeClass("breakPointCmd");
        	$(".hintedCommand").removeClass("hintedCommand");
            $("#drawArea").hide(animationRate);
        	simulating=false;
            simulateCode(false);
        	resetSimulation();
        	handleContinuationButtons();
        	showUserEntries();
        	countEntries();
    	}
    });

    $("#btnEnter").on("click touchstart",function(){
		if(simulating)timerLoop=setInterval(function(){simulateRun();},simSpeed);
    });

    $("#number-A").on("touchstart",function(){
        $("#number-A").focus();
    });

    $("#number-A").bind("keyup mouseup",function(){
        var newValue=parseInt($("#number-A").val());
        if(newValue>=parseInt($("#number-A").attr("min")) && newValue<=parseInt($("#number-A").attr("max"))){
            setParameterValue(0,newValue);
        }
        else{
            setParameterValue(0,varValues[0]);
        }
        abortSimulation();
        resetSimulation();
        handleContinuationButtons();
    });

    $(".cellNavigation").mouseover(function(){
    	if($(this).css("opacity")>0){
      	  $("#"+this.id).fadeTo(0,1);
    	  $("#"+this.id).css({
    		  "background-color" : "#c0c0c0",
    		  "box-shadow" : "1px 1px 2px #000000,2px 2px 4px #505050,3px 3px 6px #a0a0a0"
    	  });
    	}
    });
    
    $(".cellNavigation").mouseout(function(){
    	if($(this).css("opacity")>0){
        	$(this).fadeTo(0,0.5);
        	$(this).css({
        		"background-color" : "#ffffff",
        		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
        	});
    	}
    });
}

function setParameterValue(paramIndex,newValue){
	$("#number-"+String.fromCharCode(65+paramIndex)).val(newValue);
	varValues[paramIndex]=newValue;
	if(paramIndex==0){
	    pSim=newValue;
	    varValues[paramIndex]=pSim;
	}
}

function handleMouseDown(){
}

function handleMouseUp(){
}

function handleMouseMove(){
	if(debugMode) document.getElementById("debug").innerHTML="mX="+mX+" mY="+mY+" promptID="+promptID+" , "+slctdNo;
}

function handleMouseOut(){
}

function placeContents(){
	codeTopBorder=$("#buttonArea").outerHeight();
	drawTopBorder=codeTopBorder+$("#leftDiv").outerHeight()+verticalBorder;
	commentTopBorder=commentTopBorder+$("#commentArea").outerHeight()+2*verticalBorder;
	
	$("#leftDiv").css({left: horizontalBorder, top: codeTopBorder});
    codeLeftBorder=$("#leftDiv").outerWidth()+2*horizontalBorder;

	$("#algorithmStart").css({left: codeLeftBorder, top: codeTopBorder});
	$("#commentArea").css({left: codeLeftBorder, top: commentTopBorder, width: $("#algorithmStart").width(), height: 40});
	$("#drawArea").css({top: drawTopBorder});
	//"Πάνω" κουμπιά
	$("#btnFirst").css({left: -$("#btnFirst").width(), top: 0});
    $("#btnPrevious").css({left: -$("#btnFirst").width(), top: $("#btnFirst").outerHeight()});
    //"Κάτω" κουμπιά
    $("#btnLast").css({left: -$("#btnFirst").width(), top: $("#visualisation").position().top+$("#visualisation").outerHeight()-$("#btnLast").outerHeight()});
    $("#btnNext").css({left: -$("#btnFirst").width(), top: $("#btnLast").position().top-$("#btnNext").outerHeight()});
    //Επιφάνεια σχεδίασης

    $("#visualisation").css({left: $("#btnLast").position().left+$("#btnLast").outerWidth()+horizontalBorder, top: 0});
    $("#drawArea").height($("#visualisation").height+2*verticalBorder);
    //περιοχή ειδοποιήσεων
    promptTopBorder=$("#algorithmStart").position().top+$("#algorithmStart").height()+1.5*verticalBorder;
    $("#promptArea").css({top: promptTopBorder});
}

function adjustCode(){
	var j=-1;
	var html="<code class='algorithm'>";
    html+="\n<span class='algoCmd' id='cmd0'><span class='reservedWord'>ΔΙΑΒΑΣΕ</span> α</span>   <span class='showValues' id='input'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd1'><span class='reservedWord'>ΑΝ</span> "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional0'></span>";
    html+="\n<span class='algoCmd' id='cmd2'>  <span class='reservedWord'>ΓΡΑΨΕ</span> \"Το ποσό δε μπορεί να δοθεί.\"</span>   <span class='showValues' id='output1'></span>";
    html+="\n<span class='algoCmd' id='cmd3'><span class='reservedWord'>ΑΛΛΙΩΣ</span></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd4'>  υ <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='remainder'></span>";
    //j++;
    //html+="\n<span class='algoCmd' id='cmd5'>  <span class='reservedWord'>ΑΝ</span> υ = 10"+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional1'></span>";
    html+="\n<span class='algoCmd' id='cmd5'>  <span class='reservedWord'>ΑΝ</span> υ = 10 <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional1'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd6'>    x <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='xVal1'></span>";
    //j++;
    //html+="\n<span class='algoCmd' id='cmd7'>  <span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> υ = "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional2'></span>";
    html+="\n<span class='algoCmd' id='cmd7'>  <span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> υ = 20 <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional2'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd8'>    x <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='xVal2'></span>";
    //j++;
    //html+="\n<span class='algoCmd' id='cmd9'>  <span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> υ = "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional3'></span>";
    html+="\n<span class='algoCmd' id='cmd9'>  <span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> υ = 30 <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional3'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd10'>    x <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='xVal3'></span>";
    //j++;
    //html+="\n<span class='algoCmd' id='cmd11'>  <span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> υ = "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional4'></span>";
    html+="\n<span class='algoCmd' id='cmd11'>  <span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> υ = 40 <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='conditional4'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd12'>    x <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='xVal4'></span>";
    html+="\n<span class='algoCmd' id='cmd13'>  <span class='reservedWord'>ΑΛΛΙΩΣ</span></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd14'>    x <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='xVal5'></span>";
    html+="\n<span class='algoCmd' id='cmd15'>  <span class='reservedWord'>ΤΕΛΟΣ_ΑΝ</span></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd16'>  y <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='yVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd17'>  <span class='reservedWord'>ΓΡΑΨΕ</span> x , y</span>";
    html+="\n<span class='algoCmd' id='cmd18'><span class='reservedWord'>ΤΕΛΟΣ_ΑΝ</span></span>";
    html+="</code>";
	$("#algorithmStart").html(html);

	//Προσθήκη event παρακολούθησης εισόδου χρήστη σε κάθε editable τμήμα
    for(var i=0;i<noOfEntries;i++){
    	if(document.getElementById("usrEntr"+i)){
            document.getElementById("usrEntr"+i).addEventListener("input", function() {
        	    saveUserEntry(this.id);
        	}, false);
    	}
    }    	
}

function showProblem(){
	$("#leftDiv").css({left: 0, top: codeTopBorder});
	$("#problemWording").html(getProblemWording());
}

function getProblemWording(){
    var html="Οι Αυτόματες Ταμειολογιστικές Μηχανές (ΑΤΜ) δίνουν χαρτονομίσματα <b>μόνο</b> των 20€ και 50€.";
    html+=" Αυτό λοιπόν σημαίνει ότι δε μπορεί να γίνει ανάληψη οποιουδήποτε ποσού.</p>";
    html+="<p>Ο ενσωματωμένος αλγόριθμος των ΑΤΜ ζητά από τον πελάτη το επιθυμητό ποσό <span class='suggestedName'>α</span> και κατόπιν ελέγχει αν αυτό μπορεί να δοθεί.";
    html+=" Εφόσον αυτό είναι δυνατό, υπολογίζει το ελάχιστο πλήθος <span class='suggestedName'>x</span> χαρτονομισμάτων των 20 € και <span class='suggestedName'>y</span> των 50 € που απαιτούνται. Στην αντιθετη περίπτωση εμφανίζει κατάλληλο διαγνωστικό μήνυμα.</p>";
    html+="<p>Το διπλανό απόσπασμα προορίζεται για την κωδικοποίηση αυτής της λογικής.";
	html+=" Προσπάθησε να συμπληρώσεις τα κενά του, ώστε να λειτουργεί κατά τα αναμενόμενα.</p>";
	return html;
}

function showButtonCaptions(){
	if(buttonCaptionsVisible){
        $("#btnCheckCode").html("Υποβολή");
        $("#btnShowSolution").html("Λύση");
        $("#btnInitialiseCode").html("Επαναφορά");
        $("#btnPlay").html("Έναρξη");
        $("#btnStop").html("Αρχικοποίηση");
        $("#btnPause").html("Παύση");
        $("#btnContinue").html("Συνέχεια");
        $("#btnForward").html("Επόμενο");
        $("#btnOptions").html("Ρυθμίσεις");
        $(".btnMenu").css({"width":"175px"});
        $(".buttonData").width(160);
 	}
	else{
        $("#btnCheckCode").html("");
        $("#btnShowSolution").html("");
        $("#btnInitialiseCode").html("");
        $("#btnPlay").html("");
        $("#btnStop").html("");
        $("#btnPause").html("");
        $("#btnContinue").html("");
        $("#btnForward").html("");
        $("#btnOptions").html("");
        $(".btnMenu").css({"width":"30px"});
        $(".buttonData").width(40);
    }
	placeContents();
}

function showPrompt(){
	var msg="";
    switch(promptID){
        case promptToFillInBlanks:
            msg="Προσπάθησε να λύσεις το πρόβλημα, συμπληρώνοντας ορθά τα κενά των εντολών που βλέπεις.";
            msg+="<br>Μπορείς να επισκοπήσεις την ανάλυση του προβλήματος με το ομώνυμο κουμπί.";
            msg+="<br>Μπορείς να ελέγξεις την άποψή σου με το κουμπί [Υποβολή], ή να ";
            msg+="δεις την ορθή εκδοχή του προγράμματος με το κουμπί [Λύση]";
            break;
        case promptToRunCode:
            msg="Αν θεωρείς τη λύση ολοκληρωμένη, 'τρέξε' το πρόγραμμά σου με το κουμπί [Έναρξη].";
            msg+=" Επιλέγοντας μία εντολή, μπορείς να προσθέσεις Σημείο Διακοπής (Breakpoint).";
            msg+="<br>Εναλλακτικά, δοκίμασε τη βηματική εκτέλεση με το κουμπί [Επόμενο].";
            //msg+="<br>Χρησιμοποίησε τις Ρυθμίσεις Προσομοίωσης για να προβάλλεις πρόσθετες πληροφορίες υπό μορφή επεξηγήσεων.";
            break;
        case promptDuringRunning:
            if($("#btnContinue").is(":visible")){
                msg="Χρησιμοποίησε το κουμπί [Επόμενο] για να εκτελεστεί η επόμενη εντολή.";
                msg+="<br>Χρησιμοποίησε το κουμπί [Συνέχεια] για να επιστρέψεις στην αυτόματη εκτέλεση.";
            }
            else{
                msg="Χρησιμοποίησε το κουμπί [Παύση] για να διακόψεις την αυτόματη εκτέλεση.";
            }
            msg+="<br>Χρησιμοποίησε το κουμπί [Αρχικοποίηση] για να τερματίσεις την αυτόματη εκτέλεση.";
            break;
        case promptAtEndOfRun:
            msg="Χρησιμοποίησε το κουμπί [Αρχικοποίηση] για να διαγράψεις τα αποτελέσματα της εκτέλεσης του προγράμματος.";
            break;
        case promptSubmittedSolution:
            if(errorsFound){
                msg="Η εκδοχή που προτείνεις δεν είναι σωστή.";
                msg+="<br>Μελέτησε προσεκτικότερα την εκφώνηση του προβλήματος, προσπαθώντας να αναλύσεις πλήρως το πρόβλημα.";
            }
            else{
                if(solutionType==userSolution){
                    msg="Πράγματι βρήκες μία λύση του προβλήματος";
                }
                else{
                    msg="Αυτή που βλέπεις είναι μία λύση του προβλήματος";
                }
                /*if(solutionShown>-1){
                  if(solutionShown<optimalSolutionLimit){
                      msg+=" και μάλιστα βέλτιστη ως προς το πλήθος των ελεγχόμενων συνθηκών";
                      if(solutionType==userSolution){
                          msg+=".<br>Βλέπεις λοιπόν ότι η προσεκτική παράθεση των περιπτώσεων (από την ειδικότερη στην πιο γενική) μπορεί να μειώσει το πλήθος των συνθηκών, συνεπώς την <i>έκταση</i> του κώδικα και το <i>χρόνο εκτέλεσής</i> του";
                      }
                  }
                  else{
                      msg+=" αλλά υπάρχουν άλλες παραλλαγές που ελέγχουν λιγότερες συνθήκες";
                  }
                }*/
                msg+=".<br>'Τρέξε' τώρα το πρόγραμμα για να δοκιμάσεις τη λειτουργία του για διάφορες τιμές της μεταβλητής α.";
            }
            break;
    }
    $("#prompt").html(msg);
}

function showUserEntries(){
    var code;
    for(var i=0;i<noOfEntries;i++){
        code="ˍˍˍ";
        if(userEntries[i]!=null && userEntries[i]!=""){
            code=userEntries[i];
        }
        $("#usrEntr"+i).html(code);
    }
}

function showSolution(){
    var selectedPart="";
	if(requestConfirmationState || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
	    while(selectedSolution==previousSelectedSolution){
	        selectedSolution=parseInt(Math.random()*officialEntries.length);
	    }
	    previousSelectedSolution=selectedSolution;
	    solutionShown=selectedSolution;
		
	    for(var i=0;i<noOfEntries;i++){
            if(Array.isArray(officialEntries[selectedSolution][i])){
                var assembleEntry=""; 
                for(var j=0;j<officialEntries[selectedSolution][i].length;j++){
                    assembleEntry+=officialEntries[selectedSolution][i][j];
                    if(j<officialEntries[selectedSolution][i].length-1){
                        assembleEntry+=" Ή ";
                    }
                }
                selectedPart=assembleEntry;
            }
            else{
                selectedPart=officialEntries[selectedSolution][i];
            }
		    $("#usrEntr"+i).html(selectedPart);		    
		}
		solutionType=officialSolution;
		promptID=promptSubmittedSolution;
		showPrompt();

		abortSimulation();
        resetSimulation();
        handleContinuationButtons();
	}
}

function checkCode(){
    var submitted;
    var official;
    var solutionOK=false;
    var slnToCheck=0;
    while(slnToCheck<officialEntries.length && !solutionOK){
        solutionOK=true;
        var i=0;
        while(i<noOfEntries && solutionOK){
            submitted=trimSpaces(document.getElementById("usrEntr"+i).textContent.toLowerCase());
            official=officialEntries[slnToCheck][i];
            if(Array.isArray(official)){
                solutionOK=checkCombination(submitted,official);
            }
            else{
                official=trimSpaces(officialEntries[slnToCheck][i].toLowerCase());
                solutionOK=submitted==official;
            }
            
            i++;
        }
        slnToCheck++;
    }
    if(solutionOK){
        solutionShown=slnToCheck-1;
        errorsFound=false;
        if(debugMode)alert("Πολύ σωστά!");
    }
    else{
        solutionShown=-1;
        errorsFound=true;
        if(debugMode)alert("Υπάρχουν λάθη...");
    }
    promptID=promptSubmittedSolution;
    showPrompt();
    enableCodeSimulation();
}

function checkCombination(expr,cc){
    var errorsFound=false;
    for(var condIndx=0;condIndx<cc.length;condIndx++){
        var entry=trimSpaces(cc[condIndx].toLowerCase());
        var j=expr.indexOf(entry);
        if(j>-1){
            var exprStart=expr.substr(0,j);
            var exprEnd=expr.substr(j+entry.length,expr.legnth);
            expr=exprStart+exprEnd;
        }
    }
    for(var orIndx=0;orIndx<cc.length-1;orIndx++){
        var j=expr.indexOf("η");
        if(j>-1){
            var exprStart=expr.substr(0,j);
            var exprEnd=expr.substr(j+1,expr.legnth);
            expr=exprStart+exprEnd;
        }
        else{
            errorsFound=true;
        }
    }
    if(expr!="" || errorsFound){
        return false;
    }
    else{
        return true;
    }
}

function checkAgainstArray(submitted,j){
    var result=false;
    var official="";
    var i=0;
    while(!result && i<officialEntries[j].length){
        official=trimSpaces(officialEntries[j][i].toLowerCase());
        result=result || (submitted==official);
        i++;
    }
    return result;
}

function enableCodeSimulation(){
	$("#simulateControls").show(animationRate);
	$("#dataInput").show(animationRate);
}

function simulateCode(simulationSwitch){
	if(simulationSwitch){
	    $("#drawArea").show(animationRate);
	    /*mSimLimit=mSimLimitMin()+parseInt(Math.random()*10);*/
		//έναρξη προσομοίωσης με κλήση timer
		timerLoop=setInterval(function(){simulateRun();},simSpeed);
	}
	else{
		clearInterval(timerLoop);
		simulating=false;
		$("#btnContinue").hide();
		$("#btnForward").hide();
    	$("#btnPlay").hide();
    	$("#btnPause").prop("disabled",true);
    	$("#btnStop").show();
    	$("#showOptions").show();
	}	
}

function simulateRun(){
	simulationIndex++;
	var nxtSimulationIndex=simulationIndex;
	var cmdSimulated="cmd"+simulationIndex;
	//if(showComments) showCurrentComment(cmdSimulated);
	if($("#"+cmdSimulated).hasClass("breakPointCmd")){
		$("#btnPause").click();//Παύση σε breakpoint
	}
	handleContinuationButtons();
	
	if(hideSimulationPath){
	    $(".simulatingCode").removeClass("simulatingCode");
	}
	$("#cmd"+simulationIndex).addClass("simulatingCode");
	
	//Προσομοίωση αλγόριθμου
	switch(cmdSimulated){
        case input:
        	outputMsgs.push(pSim);
            makeVisible(outputMsgs.length,forceArrayDraw);
            drawArray(firstVisibleCell);
            break;
        case if1Start:
            condition0Sim=stringLogicalValue($("#usrEntr0").text(),varNames,varValues,[],[]);
            if(condition0Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition0Sim){
                   $("#"+if1Start).addClass("conditionTrue");
                }
                else{
                    $("#"+if1Start).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(output1.substr(3,2));
                }
            }
            break;
        case output1:
        	outputMsgs.push("Το ποσό δε μπορεί να δοθεί.");
            makeVisible(outputMsgs.length,forceArrayDraw);
            drawArray(firstVisibleCell);
            nxtSimulationIndex=parseInt(output2.substr(3,2));
            break;
        case remainder:
        	remainderSim=stringExpressionValue($("#usrEntr1").text(),varNames,varValues,[],[]);
            if(remainderSim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[1]=remainderSim;
            }
            break;
        case if2Start:
            condition1Sim=stringLogicalValue("υ=10",varNames,varValues,[],[]);
            if(condition1Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition1Sim){
                   $("#"+if2Start).addClass("conditionTrue");
                }
                else{
                    $("#"+if2Start).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(xVal1.substr(3,2));
                }
            }
            break;
        case xVal1:
        	xSim=stringExpressionValue($("#usrEntr2").text(),varNames,varValues,[],[]);
            if(xSim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[2]=xSim;
                nxtSimulationIndex=parseInt(xVal5.substr(3,2));
            }
            break;
        case ElseIf1:
            condition2Sim=stringLogicalValue("υ=20",varNames,varValues,[],[]);
            if(condition2Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition2Sim){
                   $("#"+ElseIf1).addClass("conditionTrue");
                }
                else{
                    $("#"+ElseIf1).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(xVal2.substr(3,2));
                }
            }
            break;
        case xVal2:
        	xSim=stringExpressionValue($("#usrEntr3").text(),varNames,varValues,[],[]);
            if(xSim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[2]=xSim;
                nxtSimulationIndex=parseInt(xVal5.substr(3,2));
            }
            break;
        case ElseIf2:
            condition3Sim=stringLogicalValue("υ=30",varNames,varValues,[],[]);
            if(condition3Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition3Sim){
                   $("#"+ElseIf2).addClass("conditionTrue");
                }
                else{
                    $("#"+ElseIf2).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(xVal3.substr(3,2));
                }
            }
            break;
        case xVal3:
        	xSim=stringExpressionValue($("#usrEntr4").text(),varNames,varValues,[],[]);
            if(xSim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[2]=xSim;
                nxtSimulationIndex=parseInt(xVal5.substr(3,2));
            }
            break;
        case ElseIf3:
            condition4Sim=stringLogicalValue("υ=40",varNames,varValues,[],[]);
            if(condition4Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition4Sim){
                   $("#"+ElseIf3).addClass("conditionTrue");
                }
                else{
                    $("#"+ElseIf3).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(xVal4.substr(3,2));
                }
            }
            break;
        case xVal4:
        	xSim=stringExpressionValue($("#usrEntr5").text(),varNames,varValues,[],[]);
            if(xSim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[2]=xSim;
                nxtSimulationIndex=parseInt(xVal5.substr(3,2));
            }
            break;
        case Else2:
        	$("#"+Else2).addClass("conditionTrue");
        	break;
        case xVal5:
        	xSim=stringExpressionValue($("#usrEntr6").text(),varNames,varValues,[],[]);
            if(xSim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[2]=xSim;
                nxtSimulationIndex=parseInt(xVal5.substr(3,2));
            }
            break;
        case endIf2:
            //μην κάνεις τίποτε
            break;
        case yVal:
        	ySim=stringExpressionValue($("#usrEntr7").text(),varNames,varValues,[],[]);
            if(ySim=="error"){
                abortSimulation();
                return;
            }
            else{
                varValues[3]=ySim;
            }
            break;
        case output2:
        	outputMsgs.push(xSim+" , "+ySim);
            makeVisible(outputMsgs.length,forceArrayDraw);
            drawArray(firstVisibleCell);
            break;
        case endIf1:
            //μην κάνεις τίποτε
            break;
	}
	showSimulationValues();
	if(simulationIndex>parseInt(endIf1.substr(3,2))){//Μετά την προσομοίωση της τελευταίας εντολής τερμάτισε το μηχανισμό προσομοίωσης
		simulateCode(false);
		promptID=promptAtEndOfRun;
	}
	simulationIndex=nxtSimulationIndex;
	showPrompt();
}

function showCurrentComment(cmdSimulated){
	var comment="";
	switch(cmdSimulated){
	case init1:
	    comment="Αρχικοποίηση αθροιστή.";
	    break;
	case init2:
		comment="Καθορισμός καθισμάτων που διατίθενται στην πρώτη σειρά.";
	    break;
	case LoopStart:
	    comment="Όρια Δομής Επανάληψης για τη σάρωση όλων των σειρών καθισμάτων της αίθουσας.";
        break;
	case updateSum:
		comment="Ενημέρωση αθροιστή με το πλήθος καθισμάτων της τρέχουσας σειράς.";
		break;
	case updateAdder:
		comment="Υπολογισμός καθισμάτων για την επόμενη σειρά της αίθουσας.";
		break;
    case LoopEnd:
        comment="Επόμενη τιμή του μετρητή της Δομής Επανάληψης";
        break;
	case outputSum:
		comment="Εμφάνιση του τελικού αποτελέσματος.";
		break;
	}
	$("#commentArea").html(comment);
}

function makeVisible(cellIndex,forceDrawFlag){
	var arrayNotDrawn=true;
	while(cellTop(cellIndex,firstVisibleCell)>canvas.height-cellSize){
		firstVisibleCell++;
		drawArray(firstVisibleCell);
		arrayNotDrawn=false;
	}
	while(cellTop(cellIndex,firstVisibleCell)<0){
		firstVisibleCell--;
		drawArray(firstVisibleCell);
		arrayNotDrawn=false;
	}
	if(forceDrawFlag && arrayNotDrawn) drawArray(firstVisibleCell);
	handleNavigationButtons();
}

function handleContinuationButtons(){
	if(simulating)return;
	if(simulationIndex>parseInt(endIf1.substr(3,2))){
		$("#btnForward").prop("disabled",true);
	}
	else{
		$("#btnForward").prop("disabled",false);
	}
}

function clearSimulated(){
	$(".simulatingCode").removeClass("simulatingCode");
	$(".conditionTrue").removeClass("conditionTrue");
	$(".conditionFalse").removeClass("conditionFalse");
	$(".conditionInError").removeClass("conditionInError");
}

function resetSimulation(){
	initialiseArray();
	resetErrorMessages();
	clearSimulated();
	simulationIndex=-1;
	handleContinuationButtons();
	showSimulationValues();
	$("#commentArea").html("");
}

function generateEntryPlaceholder(entryID,presetValue,editableState){
	var content="ˍˍˍ";
	var classToShow=(editableState)?"class='toChange'":"";
	if(presetValue!== undefined)content=presetValue;
	var newEntry="<span "+classToShow+" id='"+entryID+"' contenteditable='true'>"+content+"</span>";
	return newEntry;
}

function initialiseGraphics(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    //Πλάτος καμβά ίσο με το διαθέσιμο πλάτος προβολής
    cntx.canvas.width=$("#leftDiv").width();
    initialiseArray();
}

function initialiseArray(){
    loopStarted=false;
    firstRepetitionComplete=false;
    outputMsgs=[];
	handleArray(0);
}

function drawArray(startingCell){
	cntx.clearRect(0,0,canvas.width,canvas.height);
	var i;
	for(i=0;i<outputMsgs.length;i++){
		drawCell(i,startingCell);
	}
}

function drawCell(i,startingCell){
	var topCoord=cellTop(i,startingCell);
	//Μη σχεδιάζεις κελιά εκτός ορατών ορίων
	if(topCoord<0 || topCoord>canvas.height) return;
	
    var content=outputMsgs[i]+"";
    cntx.font="22px Georgia";
    var contentLeft=horizontalBorder;
    cntx.fillText(content,contentLeft,topCoord+cellSize-(cellSize-20)/2);
}

function cellTop(i,startingCell){
	return (i-startingCell)*cellSize;
}

function handleArray(step){
	firstVisibleCell+=step;
	handleNavigationButtons();
	drawArray(firstVisibleCell);
}

function handleNavigationButtons(){
	if(outputMsgs.length==0){
        $("#btnFirst").fadeTo(0,0);
        $("#btnPrevious").fadeTo(0,0);
        $("#btnNext").fadeTo(0,0);
        $("#btnLast").fadeTo(0,0);
	}
	else if(firstVisibleCell<=0){
		$("#btnNext").fadeTo(0,0.5);
		$("#btnLast").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0);
		$("#btnFirst").fadeTo(0,0);
    	$("#btnPrevious").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
    	$("#btnFirst").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		firstVisibleCell=0;
	}
	else if(firstVisibleCell>=Math.max(outputMsgs.length-1,0)){
		$("#btnFirst").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0.5);
		$("#btnNext").fadeTo(0,0);
    	$("#btnNext").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		$("#btnLast").fadeTo(0,0);
    	$("#btnLast").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		firstVisibleCell=Math.max(outputMsgs.length-1,0);
	}
	else{
		$("#btnFirst").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0.5);
		$("#btnNext").fadeTo(0,0.5);
		$("#btnLast").fadeTo(0,0.5);
	}
}

function showSimulationValues(){
	if(!showVarValues) return;
	
	
	//input
	if(simulationIndex==parseInt(input.substr(3,2))){
		$("#input").html(" α="+pSim+" ");
		$("#input").show(animationRate);
	}
	else{
		$("#input").html("");
		$("#input").hide(animationRate);
	}
	
	//Συνθήκη πρώτου ΑΝ
	if(simulationIndex==parseInt(if1Start.substr(3,2))){
		$("#conditional0").html(" Σ1="+greekLogicalResult(condition0Sim)+" ");
		$("#conditional0").show(animationRate);
	}
	else{
		$("#conditional0").html("");
		$("#conditional0").hide(animationRate);
	}
	
	//1ο μήνυμα εξόδου
	if(simulationIndex==parseInt(output1.substr(3,2))){
		$("#output1").html(" διαγνωστικό μήνυμα ");
		$("#output1").show(animationRate);
	}
	else{
		$("#output1").html("");
		$("#output1").hide(animationRate);
	}
	
	//Υπολογισμός υπόλοιπου
	if(simulationIndex==parseInt(remainder.substr(3,2))){
		$("#remainder").html(remainderSim+" ");
		$("#remainder").show(animationRate);
	}
	else{
		$("#remainder").html("");
		$("#remainder").hide(animationRate);
	}

	//1η συνθήκη δεύτερης ΑΝ
	if(simulationIndex==parseInt(if2Start.substr(3,2))){
		$("#conditional1").html(" Σ2="+greekLogicalResult(condition1Sim)+" ");
		$("#conditional1").show(animationRate);
	}
	else{
		$("#conditional1").html("");
		$("#conditional1").hide(animationRate);
	}

	//1ος υπολογισμός x
	if(simulationIndex==parseInt(xVal1.substr(3,2))){
		$("#xVal1").html(xSim+" ");
		$("#xVal1").show(animationRate);
	}
	else{
		$("#xVal1").html("");
		$("#xVal1").hide(animationRate);
	}

	//2η συνθήκη δεύτερης ΑΝ
	if(simulationIndex==parseInt(ElseIf1.substr(3,2))){
		$("#conditional2").html(" Σ3="+greekLogicalResult(condition2Sim)+" ");
		$("#conditional2").show(animationRate);
	}
	else{
		$("#conditional2").html("");
		$("#conditional2").hide(animationRate);
	}

	//2ος υπολογισμός x
	if(simulationIndex==parseInt(xVal2.substr(3,2))){
		$("#xVal2").html(xSim+" ");
		$("#xVal2").show(animationRate);
	}
	else{
		$("#xVal2").html("");
		$("#xVal2").hide(animationRate);
	}

	//3η συνθήκη δεύτερης ΑΝ
	if(simulationIndex==parseInt(ElseIf2.substr(3,2))){
		$("#conditional3").html(" Σ4="+greekLogicalResult(condition3Sim)+" ");
		$("#conditional3").show(animationRate);
	}
	else{
		$("#conditional3").html("");
		$("#conditional3").hide(animationRate);
	}

	//3ος υπολογισμός x
	if(simulationIndex==parseInt(xVal3.substr(3,2))){
		$("#xVal3").html(xSim+" ");
		$("#xVal3").show(animationRate);
	}
	else{
		$("#xVal3").html("");
		$("#xVal3").hide(animationRate);
	}

	//4η συνθήκη δεύτερης ΑΝ
	if(simulationIndex==parseInt(ElseIf3.substr(3,2))){
		$("#conditional4").html(" Σ5="+greekLogicalResult(condition4Sim)+" ");
		$("#conditional4").show(animationRate);
	}
	else{
		$("#conditional4").html("");
		$("#conditional4").hide(animationRate);
	}

	//4ος υπολογισμός x
	if(simulationIndex==parseInt(xVal4.substr(3,2))){
		$("#xVal4").html(xSim+" ");
		$("#xVal4").show(animationRate);
	}
	else{
		$("#xVal4").html("");
		$("#xVal4").hide(animationRate);
	}

	//5ος υπολογισμός x
	if(simulationIndex==parseInt(xVal5.substr(3,2))){
		$("#xVal5").html(xSim+" ");
		$("#xVal5").show(animationRate);
	}
	else{
		$("#xVal5").html("");
		$("#xVal5").hide(animationRate);
	}

	//υπολογισμός y
	if(simulationIndex==parseInt(yVal.substr(3,2))){
		$("#yVal").html(ySim+" ");
		$("#yVal").show(animationRate);
	}
	else{
		$("#yVal").html("");
		$("#yVal").hide(animationRate);
	}

	//2ο μήνυμα εξόδου
	if(simulationIndex==parseInt(output2.substr(3,2))){
		$("#output2").html(xSim+" , "+ySim+" ");
		$("#output2").show(animationRate);
	}
	else{
		$("#output2").html("");
		$("#output2").hide(animationRate);
	}
}

function greekLogicalResult(originalVal){
    if(originalVal){
        return "ΑΛΗΘΗΣ";
    }
    else{
        return "ΨΕΥΔΗΣ";
    }
}

function saveUserEntry(entryID){
    
	entryIndex=parseInt(entryID.substr("usrEntr".length,2));
	userEntries[entryIndex]=trimSpaces($("#"+entryID).html());
    solutionType=userSolution;
    countEntries();
}

function countEntries(){
    var filledEntries=0;
    for(var i=0;i<userEntries.length;i++){
        if(userEntries[i]!=null && userEntries[i]!="")filledEntries++;
    }
    if(filledEntries==noOfEntries){
        //$("#solutionControls").show(animationRate); //Τα controls είναι ήδη ορατά από εκπαιδευτική άποψη
        promptID=promptToRunCode;
    }
    else{
        promptID=promptToFillInBlanks;
    }
    showPrompt();
}

function abortSimulation(){
    simulationAborted=true;
	$("#btnStop").click();
}

function showMatches(index){
    switch(index){
    case 1:
        $("#cmd0").addClass("matched");
        break;
    case 2:
        $("#cmd1").addClass("matched");
        break;
    case 3:
        $("#cmd2").addClass("matched");
        $("#cmd5").addClass("matched");
        break;
    case 4:
        $("#cmd3").addClass("matched");
        break;
    case 5:
        $("#cmd4").addClass("matched");
        break;
    case 6:
        $("#cmd6").addClass("matched");
        break;
    }    
}

function updateSimulationInfo(){
    document.getElementById("mCurrent").innerHTML=mSim;
    document.getElementById("currentHeight").innerHTML=hSim+" €";
}

Number.prototype.formatNumber=function(c, d, t){
    var n=this, 
    c=isNaN(c = Math.abs(c)) ? 2 : c, 
    d=d == undefined ? "." : d, 
    t=t == undefined ? "," : t, 
    s=n < 0 ? "-" : "", 
    i=String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))), 
    j=(j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
 };
 
 function showAnalysis(){
	 
 }